<?php

namespace Machine;

class Definitions
{
	public const G = [
		// traverse mode
		0  => 'Rapid traverse',  // Default
		1  => 'Linear interpolation',
		2  => 'Circular interpolation (CW)',
		3  => 'Circular interpolation (CCW)',

		// quest-ce-que c'est?
		4  => 'Dwell',

		// plane selection mode
		17 => 'Plane selection (XY-plane)', // Default
		18 => 'Plane selection (XZ-plane)',
		19 => 'Plane selection (YZ-plane)',

		// extra functionality (one shot)
		21 => 'Parameter definition for SP (G21 E1 X1000 sets E1 to 1000)',
		22 => 'Call up of SP through X',
		23 => 'Addition of parameters in SP (G23 E030201 sets E03 = E02 + E01)',
		24 => 'Subtraction of parameters in SP (G23 E030201 sets E03 = E02 - E01)',
		25 => 'Parameter association in SP for storing',
		26 => '100% feed, no override possible',
		29 => 'Skip instruction in SP (G29 E2 X50 means jump to after 50 if E2 > 0)',

		// radius compensation mode
		40 => 'Radius compensation not effective', // default
		41 => 'Radius compensation to left of workpiece',
		42 => 'Radius compensation to right of workpiece',
		43 => 'Radius compensation, axially parallel, positive',
		44 => 'Radius compensation, axially parallel, negative',

		// call workcycle
		79 => 'Activation of a work cycle',

		// work cycle selection
		81 => 'Work cycle for drilling',
		84 => 'Work cycle for tapping',
		85 => 'Work cycle for reaming',
		86 => 'Work cycle for boring',

		// dimension modes
		90 => 'Absolute dimension programming', // Default
		91 => 'Incremental dimension programming',

		// shift zero datum (one shot)
		92 => 'Incremental zero datum shift',
		93 => 'Absolute zero datum shift',

		// reference to zero
		98 => 'Automatic positioning to reference datum point',
	];

	public const M = [
		0  => 'Programmed stop (Sets M5 and M9)',
		2  => 'End of program (Sets M5 and M9)',
		3  => 'Spindle start CW (CCW in G18)',
		4  => 'Spindle start CCW (CW in G18)',
		5  => 'Spindle stop',
		6  => 'Tool change (Sets M5 and M9)',

		// coolant control
		8  => 'Coolant on',
		9  => 'Coolant off',

		// table clamping (unsupported)
		10 => 'Table clamping - close',
		11 => 'Table clamping - open',

		30 => 'End of program with skip back to start (Sets M5 and M9)',
		67 => 'Enter new tool information without machine stop',
	];
}
